/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

package edu.stanford.smi.protege.code.generator.wrapping;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import edu.stanford.smi.protege.model.Instance;
import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Localizable;
import edu.stanford.smi.protege.model.Slot;
import edu.stanford.smi.protege.util.Disposable;
import edu.stanford.smi.protege.util.LocalizeUtils;

public abstract class AbstractWrappedInstance implements Localizable, Serializable, Disposable {
	private Instance wrappedProtegeInstance;

	protected AbstractWrappedInstance(Instance instance) {
		wrappedProtegeInstance = instance;
	}

	protected AbstractWrappedInstance() {

	}

	public Instance getWrappedProtegeInstance() {
		return wrappedProtegeInstance;
	}

	public KnowledgeBase getKnowledgeBase() {
		return wrappedProtegeInstance == null ? null : wrappedProtegeInstance.getKnowledgeBase();
	}

	public String getName() {
		return wrappedProtegeInstance.getName();
	}

	protected boolean hasSlotValues(Slot slot) {
		return getKnowledgeBase().getOwnSlotValueCount(wrappedProtegeInstance, slot) > 0;
	}

		protected void addSlotValue(Slot slot, Object value) {
		wrappedProtegeInstance.addOwnSlotValue(slot, getUnwrappedObject(value));
	}

	protected void removeSlotValue(Slot slot, Object value) {
		wrappedProtegeInstance.removeOwnSlotValue(slot, getUnwrappedObject(value));
	}

	protected void setSlotValue(Slot slot, Object value) {
		wrappedProtegeInstance.setOwnSlotValue(slot, getUnwrappedObject(value));
	}

	protected void setSlotValues(Slot slot, Collection<?> values) {
		wrappedProtegeInstance.setOwnSlotValues(slot, getUnwrappedCollection(values));
	}

	public boolean canAs(Class<?> javaInterface) {
		return OntologyJavaMappingUtil.canAs(this, javaInterface);
	}

	public <X> X as(Class<? extends X> javaInterface) {
		return OntologyJavaMappingUtil.as(this, javaInterface);
	}

	public void delete() {
		wrappedProtegeInstance.delete();
	}

	@SuppressWarnings("unchecked")
	private Collection<?> getUnwrappedCollection(Collection<?> values) {
		Collection newValues = new ArrayList();
		for (Object value : values) {
			newValues.add(getUnwrappedObject(value));
		}
		return newValues;
	}

	private Object getUnwrappedObject (Object value) {
		if (value instanceof AbstractWrappedInstance) {
			value = ((AbstractWrappedInstance) value).getWrappedProtegeInstance();
		}
		return value;
	}


    @Override
    public boolean equals(Object obj) {
    	if (!(obj instanceof AbstractWrappedInstance)) {
    		return false;
    	}

    	return ((AbstractWrappedInstance)obj).getWrappedProtegeInstance().equals(getWrappedProtegeInstance());
    }

    @Override
    public int hashCode() {
    	return getWrappedProtegeInstance().getName().length() + 42;
    }
    
    public void localize(KnowledgeBase kb) {
        LocalizeUtils.localize(wrappedProtegeInstance, kb);
    }

    public void dispose() {
    	wrappedProtegeInstance = null;    	
    }
    
    
    @Override
    public String toString() {
    	return getName();
    }
}
